Background job and dedicated status for project deletion
Description

Due to the deletion of dependent objects (issues etc) and child projects,

project deletion may take a long time.

This patch, which was extracted from [Planio](https:/plan.io/redmine-hosting),

moves the actual project deletion into an ActiveJob job. It also introduces a

new project status (SCHEDULED_FOR_DELETION) that is used to effectively hide

the project that is about to be deleted (and any potential descendant projects)

from the system immediately.

A security notification is sent out to the user who deleted the project,

informing about success / failure.

The projects list is extended to be able to filter for the new status,

s0 in case of a failure, the project can still be accessed for

examination.

Related issues:

Related to Redmine - Patch #31076: Issues CSV / PDF export via ActiveJob New
Related to Redmine - Feature #33422: Re-implement admin project list using Pr... Closed
Related to Redmine - Patch #37210: Make "Project" label translatable in app/v... Closed

Associated revisions

Revision 21591 - 2022-05-17 22:45 - Marius BALTEANU
Background job for project deletion (#36691).

Due to the deletion of dependent objects (issues etc), project deletion may take a long time.

This patch moves the actual project deletion into an ActiveJob job. It also introduces a new project status (SCHEDULED_FOR_DELETION) that is
used to effectively hide the project that is about to be deleted (and any potential descendant projects) from the system immediately.

A security notification is sent out to the user that deleted the project, informing about success / failure.

The projects list is extended to be able to filter for the new status, so in case of a failure, the project can still be accessed for examination.

Patch by Jens Kramer.

Revision 21592 - 2022-05-17 22:50 - Marius BALTEANU
Adds projects bulk delete (#36691).

Patch by Jens Kramer.

Revision 21593 - 2022-05-17 22:53 - Marius BALTEANU
Fix random failing tests (#36691).

Patch by Jens Kramer.

Revision 21598 - 2022-05-19 10:14 - Marius BALTEANU
Remove test code (#36691).
Revision 21602 - 2022-05-25 15:32 - Go MAEDA
Update locales (#36691).

Revision 21624 - 2022-06-06 11:06 - Go MAEDA
Make "Project" label translatable in app/views/projects/bulk_destroy.html.erb (#36691, #37210).

Patch by Robert Korulczyk.

History

#1 - 2022-02-23 22:58 - Marius BALTEANU

- Target version set to Candidate for next major release

Nice feature!

#2 - 2022-02-23 23:00 - Marius BALTEANU
- Related to Patch #31076: Issues CSV / PDF export via ActiveJob added

#3 - 2022-02-23 23:07 - Marius BALTEANU

Jens, should we take into consideration also #349877?

#4 - 2022-02-24 00:24 - James H

maybe my group members issue #36696 can benefit from this as well

#5 - 2022-02-24 03:43 - Jens Kramer
Marius BALTEANU wrote:

Jens, should we take into consideration also #349877

Ah, that's interesting. If | understand correctly, that would mean the project record (plus potential child projects' records) would be deleted
synchronously, but removal of all dependent objects would be pushed to the job queue.

| see few problems with that:

1. Data integrity. Before the job is finished, we have an inconsistent database (i.e. issues referencing a nonexisting project). | am not sure we handle
such a situation gracefully (i.e. resulting in an HTTP 404 vs a 500) in all cases.

2. Two transactions instead of one. Currently, if the project deletion fails due to a problem somewhere along the way (due to a failing callback for
example), the transaction is rolled back and everything is as if nothing happened. Splitting the process in two separate transactions (one for the
project, one later for the dependent objects), means the project record will be gone even if some dependent object insists on not being destroyed. | do
not think core has any such callbacks, but plugins might.

3. Does not work at all when there are foreign keys referencing “projects.id’. We do not have such in core, but again, there may be plugins that do.

#6 - 2022-02-24 08:46 - Marius BALTEANU

Thanks Jens for your quick response.

#7 - 2022-03-28 23:08 - Marius BALTEANU

- Target version changed from Candidate for next major release to 5.1.0

#8 - 2022-03-31 13:07 - Jens Kramer

Marius, | just have re-submitted this patch as part of a larger work on the admin projects list in #33422. It would be great if you could have a look and
consider integrating that one instead.

#9 - 2022-04-03 09:48 - Marius BALTEANU

There is a random failing test, you can reproduce by running the tests using the following command: TESTOPTS="--seed=42328" rake test
Failure:

DestroyProjectJobTest#test_should_destroy_project_and_send_email [/work/test/unit/jobs/destroy_project_job_tes
t.rb:60]:

No enqueued Jjob found with {:job=>ActionMailer::MailDeliveryJob, :args=>#<Proc:0x0000aaaafe3aec98 /work/test/u
nit/jobs/destroy_project_job_test.rb:62 (lambda)>}

Jens, can you take a look, please?
#10 - 2022-04-03 09:49 - Marius BALTEANU

- Related to Feature #33422: Re-implement admin project list using ProjectQuery system added

#11 - 2022-04-04 18:47 - Marius BALTEANU

- Assignee set to Jens Krdmer

#12 - 2022-04-06 08:19 - Jens Kramer
- File fix_failing _tests.diff added

this is really strange, looks like under some circumstances emails are processed inline and not result in a queued mailer job. | did not find the cause
of this, but the attached patch would handle both cases in the tests (the same issue exists in the test case for the job that handles deletion of multiple
projects).

#13 - 2022-05-17 22:53 - Marius BALTEANU
- Status changed from New to Resolved

- Assignee changed from Jens Krdmer to Marius BALTEANU

Both patches from #33422 and the fix for tests committed, thank you for your contribution, really useful feature.

#14 - 2022-05-27 21:38 - Marius BALTEANU

- Status changed from Resolved to Closed

#15 - 2022-06-06 10:57 - Go MAEDA
- Related to Patch #37210: Make "Project" label translatable in app/views/projects/bulk_destroy.html.erb added

#16 - 2023-10-30 13:38 - Go MAEDA
- Tracker changed from Patch to Feature

- Resolution set to Fixed

Files
0001-background-job-for-project-deletion.patch 14 KB 2022-02-23 Jens Kramer
fix_failing_tests.diff 2.8 KB 2022-04-06 Jens Kramer
